# 前言



**最重要的原则**

1.  应当尊重小组讨论的结果，如果觉得有问题，可以提出来，群智解决
2.  不是老代码烂不烂的问题，再好的代码也可能因为重构而弃用
3.  弃用的代码就该删掉，或者至少用注释划个区，标注一下弃用
4.  你不能负责整个项目，但你要负责你push上去的每个文件都是干干净净的啊

**技术说明：**

规则并不是完美的，通过禁止在特定情况下有用的特性，可能会对代码实现造成影响。但是我们制定规则的目的“为了大多数程序员可以得到更多的好处”， 如果在团队运作中认为某个规则无法遵循，希望可以共同改进该规则。 参考该规范之前，希望您具有相应的Python基础能力，而不是通过该文档来学习Python。，

**最基本的，你需要：**

1.  了解Python的PEP标准；
2.  熟知Python的基本语言特性，包和模块相关特性；
3.  了解Python的标准库；
4.  了解Pyqt5(尤其是信号与槽) 或者Qt；

**重点关注：**

1.  约定Python的编程风格，比如命名，排版等。
2.  Python的模块化设计，如何设计模块，类，接口和函数。
3.  Python、pyqt相关特性的优秀实践，比如常量，类型转换等。
4.  现代Python、pyqt的优秀实践，包括Python、pyqt中可以提高代码可维护性，提高代码可靠性的相关约定。

**约定：**

*   **规则：** 编程时必须遵守的约定(must)
*   **建议：** 编程时应该遵守的约定(should)

本规范适用通用PyMiner标准, 如果没有特定的标准版本，适用所有的版本。

**例外：**

*   无论是’规则’还是’建议’，都必须理解该条目这么规定的原因，并努力遵守。但是，有些规则和建议可能会有例外。
*   在不违背总体原则，经过充分考虑，有充足的理由的前提下，可以适当违背规范中约定。例外破坏了代码的一致性，请尽量避免。’规则’的例外应该是极少的。

**下列情况，应风格一致性原则优先：**

*   修改外部开源代码、第三方代码时，应该遵守开源代码、第三方代码已有规范，保持风格统一。
*   某些特定领域，优先参考其行业规范。

**好代码的原则：**

1.  通过所有测试（Passes its tests）
2.  尽可能消除重复 (Minimizes duplication)
3.  尽可能清晰表达 (Maximizes clarity)
4.  更少代码元素 (Has fewer elements)

以上四个原则的重要程度依次降低。